/* nifell.cmd - ell-plugin for @Nifty log saved with browser.
 *
 * uEUAy[W[ۑ]{^ĕۑA@Nifty ̉c
 * OLɉ{ ell/nuevOCłBgzip  bzip2 ňk
 * OǂނƂł܂BȂAeff 0.70ł́Aeff ̃oÔ߁A
 * gpł܂B
 *
 * gp̍ۂ́A archive  ell.cfg  _ell ɒǉĂB
 * (_nue ɂ̓ftHgŋLqĂ܂)
 *
 * archive "f*.log","f*.log.gz","f*.log.bz2" {
 *    fnamepos=1,
 *    print="nifell.cmd p",
 *    list="nifell.cmd l",
 *    rootchar="/",
 * }
 * # ell 1.16 ȍ~ł rootchar ͕svłB
 *
 * {XNvǵAOAɂ
 *	https://iw.nifty.com/iw/nifty/f....
 * ƂL[ɂāA𕪗Ă܂B
 * ł̂ŁA̕񂪌ꂽ`̃Oł͐ɓ삵܂B
 */

PARSE ARG cmdarg filename region .

IF TRANSLATE(RIGHT(filename,3)) = ".GZ" THEN DO
    '@gzip -dc' filename '| nifell.cmd' cmdarg 'STDIN:' region
    EXIT 0
END
IF TRANSLATE(RIGHT(filename,4)) = ".BZ2" THEN DO
    '@bzip2 -dc' filename '| nifell.cmd' cmdarg 'STDIN:' region
    EXIT 0
END

cmdarg = TRANSLATE(STRIP(cmdarg))

SELECT
    WHEN cmdarg = "L" THEN DO
	CALL stream filename,"C","OPEN READ"
	n = 2
	DO WHILE LINES(filename) > 0
	    line = linein(filename)
	    n = n - 1
	    IF n = 0 & line <> "" THEN
		SAY line
	    IF ABBREV(line,"https://iw.nifty.com/iw/nifty/f") = 1 THEN
		n = 2
	END
	CALL stream filename,"C","CLOSE"
    END
    WHEN cmdarg = "P" THEN DO
	CALL stream filename,"C","OPEN READ"
	region = STRIP(region,'B','"')
	n = 2
	switch = 0
	DO WHILE LINES(filename) > 0
	    line = linein(filename)
	    n = n - 1
	    IF n = 0 & ABBREV(line,region) = 1 THEN
		switch = 1
	    IF switch <> 0 THEN
		SAY line
	    IF ABBREV(line,"https://iw.nifty.com/iw/nifty/f") = 1 THEN DO 
		n = 2
		IF switch <> 0 THEN
		    LEAVE
	    END
	END
	CALL stream filename,"C","CLOSE"
    END
    OTHERWISE
    SAY "nifell.cmd : Syntax Error"
END
EXIT 0
